# Kubernetes相关资讯和情报链接

授人以鱼，不如授人以渔。下面的资料将有助于大家了解kubernetes生态圈当前发展状况和发展趋势，我特此整理相关资料如下。

## 生态环境

包括kubernetes和cloud native相关的开源软件、工具和全景图。

- [awesome-kubernetes](https://github.com/ramitsurana/awesome-kubernetes) - A curated list for awesome kubernetes sources 🚢🎉 [https://ramitsurana.github.io/awesome…](https://ramitsurana.github.io/awesome-kubernetes)
- [awesome-cloud-native](https://github.com/rootsongjc/awesome-cloud-native/) - A curated list for awesome cloud native architectures <https://jimmysong.io/awesome-cloud-native/>
- [cloud native landscape](https://github.com/cncf/landscape) - Cloud Native Landscape [https://cncf.io](https://cncf.io/)

## 开源书籍和教程

- [arun-gupta/kubernetes-aws-workshop](https://github.com/arun-gupta/kubernetes-aws-workshop)
- [arun-gupta/kubernetes-java-sample](https://github.com/arun-gupta/kubernetes-java-sample)
- [feiskyer/kubernetes-handbook](https://github.com/feiskyer/kubernetes-handbook)
- [kelseyhightower/kubernetes-the-hard-way](https://github.com/kelseyhightower/kubernetes-the-hard-way)
- [ks](https://github.com/red-gate/ks) - A series of Kubernetes walk-throughs
- [opsnull/follow-me-install-kubernetes-cluster](https://github.com/opsnull/follow-me-install-kubernetes-cluster)
- [rootsongjc/kubernetes-handbook](https://github.com/rootsongjc/kubernetes-handbook)

## 幻灯片、图书和情报资料分享

- [cloud-native-slides-share](https://github.com/rootsongjc/cloud-native-slides-share)  - Cloud Native 相关meetup、会议PPT、图书资料分享

## 博客与网站

Kubernetes和Cloud Native相关网站、专栏、博客等。

### 网站与专栏

- [thenewstack.io](https://thenewstack.io/)
- [k8sport.org](http://k8sport.org/)
- [giantswarm blog](https://blog.giantswarm.io/)
- [k8smeetup.com](http://www.k8smeetup.com)
- [dockone.io](http://www.dockone.io)
- [Cloud Native知乎专栏](https://zhuanlan.zhihu.com/cloud-native)
- [kubernetes.org.cn](https://www.kubernetes.org.cn/)

### 博客

- [aporeto](https://www.aporeto.com/blog/)
- [applatix](https://applatix.com/blog/)
- [apprenda](https://apprenda.com/blog/)
- [bitnami](https://engineering.bitnami.com/)
- [buoyant](https://buoyant.io/blog/)
- [cisco](https://blogs.cisco.com/tag/kubernetes)
- [cncf](https://www.cncf.io/newsroom/blog/)
- [codeship](https://blog.codeship.com/)
- [containership](https://blog.containership.io/)
- [coreos](https://coreos.com/blog/)
- [coscale](https://www.coscale.com/blog)
- [fabric8](https://blog.fabric8.io/)
- [grafana](https://grafana.com/blog/)
- [gravitational](https://gravitational.com/blog/)
- [heptio](https://blog.heptio.com/)
- [istio](https://istio.io/blog/)
- [jimmysong](https://jimmysong.io)
- [kubernetes](http://blog.kubernetes.io/)
- [moby](https://blog.mobyproject.org/)
- [openshift](https://blog.openshift.com/tag/kubernetes/)
- [pivotal](https://content.pivotal.io/)
- [platform9](https://platform9.com/blog/)
- [prometheus](https://prometheus.io/blog/)
- [rancher](https://rancher.com/blog/)
- [sysdig](https://sysdig.com/blog/)
- [spinnaker](https://blog.spinnaker.io)
- [supergiant](https://supergiant.io/blog)
- [thecodeteam](https://blog.thecodeteam.com/)
- [twistlock](https://www.twistlock.com/blog/)
- [vamp](https://medium.com/vamp-io)
- [weave](https://www.weave.works/blog/)
- [wercker](http://blog.wercker.com/)